"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
import dataclasses
from dataclasses_json import Undefined, dataclass_json
from enum import Enum
from fivetran import utils
from typing import Optional

class NewDestinationRequestRegionEnum(str, Enum):
    r"""Data processing location. This is where Fivetran will operate and run computation on data."""
    GCP_US_EAST4 = "GCP_US_EAST4"
    GCP_US_WEST1 = "GCP_US_WEST1"
    GCP_EUROPE_WEST3 = "GCP_EUROPE_WEST3"
    GCP_AUSTRALIA_SOUTHEAST1 = "GCP_AUSTRALIA_SOUTHEAST1"
    GCP_NORTHAMERICA_NORTHEAST1 = "GCP_NORTHAMERICA_NORTHEAST1"
    GCP_EUROPE_WEST2 = "GCP_EUROPE_WEST2"
    GCP_ASIA_SOUTHEAST1 = "GCP_ASIA_SOUTHEAST1"
    AWS_US_EAST_1 = "AWS_US_EAST_1"
    AWS_US_EAST_2 = "AWS_US_EAST_2"
    AWS_US_WEST_2 = "AWS_US_WEST_2"
    AWS_AP_SOUTHEAST_2 = "AWS_AP_SOUTHEAST_2"
    AWS_EU_CENTRAL_1 = "AWS_EU_CENTRAL_1"
    AWS_EU_WEST_1 = "AWS_EU_WEST_1"
    AWS_EU_WEST_2 = " AWS_EU_WEST_2"
    AZURE_EASTUS2 = "AZURE_EASTUS2"
    AZURE_AUSTRALIAEAST = "AZURE_AUSTRALIAEAST"
    GCP_ASIA_SOUTH1 = "GCP_ASIA_SOUTH1"


@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class NewDestinationRequest:
    
    group_id: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('group_id') }})
    r"""The unique identifier for the group within the Fivetran system."""  
    service: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('service') }})
    r"""The name for the destination type within the Fivetran system."""  
    time_zone_offset: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('time_zone_offset') }})
    r"""Determines the time zone for the Fivetran sync schedule."""  
    region: Optional[NewDestinationRequestRegionEnum] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('region'), 'exclude': lambda f: f is None }})
    r"""Data processing location. This is where Fivetran will operate and run computation on data."""  
    run_setup_tests: Optional[bool] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('run_setup_tests'), 'exclude': lambda f: f is None }})
    r"""Specifies whether setup tests should be run automatically."""  
    trust_certificates: Optional[bool] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('trust_certificates'), 'exclude': lambda f: f is None }})
    r"""Specifies whether we should trust the certificate automatically. The default value is FALSE. If a certificate is not trusted automatically, it has to be approved with [Certificates Management API Approve a destination certificate](https://fivetran.com/docs/rest-api/certificates#approveadestinationcertificate)."""  
    trust_fingerprints: Optional[bool] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('trust_fingerprints'), 'exclude': lambda f: f is None }})
    r"""Specifies whether we should trust the SSH fingerprint automatically. The default value is FALSE. If a fingerprint is not trusted automatically, it has to be approved with [Certificates Management API Approve a destination fingerprint](https://fivetran.com/docs/rest-api/certificates#approveadestinationfingerprint)."""  
    